import os
import json

directory = './training_output/logs/20230430-2211-fedweit-non_iid_50'
n_concepts = 5
num_elements = 100
metrics = 'test_local_acc'

def max(key, num_elements, metrics):
    # Iterate over all files in directory
    # Initialize list to hold sum of i-th elements for each file
    max_l = [0] * num_elements

# Initialize counter to keep track of number of files processed
    for filename in os.listdir(directory):
        # Check if file is a text file
        if filename.endswith('.txt'):
            # Read in contents of file as a dictionary
            with open(os.path.join(directory, filename), 'r') as f:
                content = f.read()
                data = json.loads(content)
                sub_data = data['scores'][metrics]
                # print(sub_data)
                # Check if key exists in dictionary and value is a list
                if key in sub_data and isinstance(sub_data[key], list):
                    # Add i-th element of list to sum
                    for i in range(num_elements):
                        if len(sub_data[key]) > i and sub_data[key][i]>max_l[i] :
                            max_l[i] = sub_data[key][i]
                    # Increment counter

    # Calculate average of i-th element for given key over all files
    print(f"Max of concept {key}:")
    for i in range(num_elements):
        print(f"Element {i}: {max_l[i]}")

for i in range(n_concepts):
    max(str(i), num_elements, metrics)