# Concept Matching: Clustering-based Federated Continual Learning

This repository is an official implementation of [Concept Matching: Clustering-based Federated Continual Learning]

## Libraries

This repository uses tensorflow and scikit-learn.

## Data Generation

This repository modifies the code from FedWeIT to download and process the data. The default data directory (i.e. data with 20 clients) is "./FedWeIT_6_Tasks/generated_task_data/5_20", which is specified in "generator.py" file. In "FedWeIT_6_Tasks" directory, please execute "python main.py --work-type gen_data --task non_iid_50 --seed 777" to generate data. For more details, please refer to README file in "FedWeIT_6_Tasks" directory. 

## Run Training
To run training, please execute "python main.py". Please replace arguments as you wish. The vanilla FL shall run with argument "--concept 1". The baseline of EWC shall run with "--concept 1", and "EWC = True" in CLFLClient.py file. The baseline of FedWeIT shall run in "FedWeIT_6_Task" directory, and please the refer to README file of the original work. 

## Run Testing
The training log and the server models are saved for each round. The server models shall be tested after the training. To run testing, please execute "python test.py". Please replace arguments as you wish.

## Results
All results are saved in the subdirectory specified by "--eid" argument. Please use "eval_metrics.ipynb" for additional metrics used in the paper.
