import tensorflow as tf
import tensorflow.keras as keras
from tensorflow.keras.layers import Embedding, LSTM, Dense, Dropout
from tensorflow.keras.models import Sequential
from tensorflow.keras.layers import Conv2D
from tensorflow.keras.layers import MaxPooling2D
from tensorflow.keras.layers import Flatten,Reshape
from numpy import genfromtxt
from numpy import loadtxt
from tensorflow.keras.utils import to_categorical
from tensorflow.keras.models import Sequential,Model
from tensorflow.keras.layers import Dense, Dropout, Reshape, GlobalAveragePooling1D,Input, LSTM,BatchNormalization,Bidirectional
from tensorflow.keras.layers import Conv1D, MaxPooling1D,Flatten, Concatenate,MaxPooling2D
from tensorflow.keras.layers import Multiply, Add, Lambda, Flatten
import tensorflow.keras.layers as layers
import tensorflow.keras.backend as K
from sklearn import preprocessing

model_seed = 13
init = 'he_uniform'


# sent_init = 'lecun_uniform'
sent_init = init

def build_model_backp():
    model = Sequential(
    [Dense(32, activation="relu",input_shape=(768,), kernel_initializer=sent_init),
    Dense(3, activation="softmax")
    ])
    return model


def build_model(TIME_PERIODS=124,num_sensors=6,num_classes=7, model_seed=13):
    tf.random.set_seed(model_seed)
    inputs = keras.Input(shape=(TIME_PERIODS,num_sensors))
    # inputs = Reshape((TIME_PERIODS, num_sensors), input_shape=(TIME_PERIODS*num_sensors,))(orig_inputs)
    c1 = Conv1D(100, 10, kernel_initializer='he_uniform', activation='relu', name='cv1_on_input')(inputs)
#     c1 = BatchNormalization()(c1)
    c2_1 = Conv1D(100, 10, kernel_initializer='he_uniform',activation='relu', name='cv_on_c1')(c1)
    p1 = MaxPooling1D(pool_size=2)(c2_1)

#     concat1 = Concatenate(axis=1)([p1, p2])
    d1 = Dropout(0.2)(p1)
    d1 = Flatten()(d1)

    fc1 = Dense(124,kernel_initializer='he_uniform', activation='relu')(d1)
    d2 = Dropout(0.2)(fc1)
    fc2 = Dense(num_classes,kernel_initializer='he_uniform', activation='softmax')(d2)

    model = Model(inputs=inputs, outputs=fc2)
    # optimizer = opt
    # optimizer = tensorflow.keras.optimizers.SGD(learning_rate=0.001)
#     model.compile(loss='categorical_crossentropy', optimizer=opt, metrics=[keras.metrics.CategoricalAccuracy()])
    return model

def femnist_model(model_seed=13):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    model.add(Reshape((28,28,1),input_shape=(784,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))
    model.add(Conv2D(32, (3, 3), activation='relu', kernel_initializer=init , input_shape=(28, 28, 1)))
    model.add(MaxPooling2D((2, 2)))
    model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((2, 2)))
    model.add(Flatten())
    model.add(Dense(100, activation='relu', kernel_initializer=init))
    model.add(Dense(62, activation='softmax', kernel_initializer=init))
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model

def multi_concept_model_small(model_seed=13, n_class=183):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    # model.add(Reshape((28,28,1),input_shape=(3072,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))
    model.add(Conv2D(10, (5, 5), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(25, (5, 5), activation='relu', kernel_initializer=init))
    # model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Dropout(0.2))
    model.add(Flatten())
    model.add(Dense(400, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(250, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(n_class, activation='softmax', kernel_initializer=init))
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model

def multi_concept_model_small0(model_seed=13, n_class=183):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    # model.add(Reshape((28,28,1),input_shape=(3072,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))
    model.add(Conv2D(16, (5, 5), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(40, (5, 5), activation='relu', kernel_initializer=init))
    # model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Dropout(0.2))
    model.add(Flatten())
    model.add(Dense(640, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(400, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(n_class, activation='softmax', kernel_initializer=init))
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model

def multi_concept_model(model_seed=13, n_class=183):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    # model.add(Reshape((28,28,1),input_shape=(3072,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))
    model.add(Conv2D(20, (5, 5), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(50, (5, 5), activation='relu', kernel_initializer=init))
    # model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Dropout(0.2))
    model.add(Flatten())
    model.add(Dense(800, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(500, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(n_class, activation='softmax', kernel_initializer=init))
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model

def multi_concept_model_large1(model_seed=13, n_class=183):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    # model.add(Reshape((28,28,1),input_shape=(3072,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))
    model.add(Conv2D(30, (5, 5), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(75, (5, 5), activation='relu', kernel_initializer=init))
    # model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Dropout(0.2))
    model.add(Flatten())
    model.add(Dense(1200, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(750, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(n_class, activation='softmax', kernel_initializer=init))
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model

def multi_concept_model_large0(model_seed=13, n_class=183):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    model.add(Conv2D(24, (5, 5), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(60, (5, 5), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Dropout(0.2))
    model.add(Flatten())
    model.add(Dense(960, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(600, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(n_class, activation='softmax', kernel_initializer=init))
    return model

def multi_concept_model_large2(model_seed=13, n_class=183):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    # model.add(Reshape((28,28,1),input_shape=(3072,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))
    model.add(Conv2D(20, (5, 5), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(20, (5, 5), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3),  strides=2))
    model.add(Conv2D(50, (5, 5), activation='relu', kernel_initializer=init))
    # model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Conv2D(50, (5, 5), activation='relu', kernel_initializer=init))
    # model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((3, 3), strides=2))
    model.add(Dropout(0.2))
    model.add(Flatten())
    model.add(Dense(800, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(500, activation='relu', kernel_initializer=init))
    model.add(Dropout(0.2))
    model.add(Dense(n_class, activation='softmax', kernel_initializer=init))
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model

def multi_concept_model_backup(model_seed=13):
    tf.random.set_seed(model_seed)    
    model = Sequential()
    #model.add(Reshape((28,28,1),input_shape=(784,)))
    # model.add(Conv2D(32, (3, 3), activation='relu', input_shape=(28, 28, 1)))

    #model.add(Conv2D(32, (3, 3), activation='relu', kernel_initializer=init , input_shape=(28, 28, 1)))
    model.add(Conv2D(32, (3, 3), activation='relu', kernel_initializer=init , input_shape=(32, 32, 3)))
    model.add(MaxPooling2D((2, 2)))
    model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(Conv2D(64, (3, 3), activation='relu', kernel_initializer=init))
    model.add(MaxPooling2D((2, 2)))
    model.add(Flatten())
    model.add(Dense(400, activation='relu', kernel_initializer=init)) # 100 -> 400
    model.add(Dense(283, activation='sigmoid', kernel_initializer=init)) # 62 -> 283
    # compile model
#     opt = SGD(learning_rate=0.01, momentum=0.9)
#     model.compile(optimizer=opt, loss='sparse_categorical_crossentropy', metrics=['accuracy'])
    return model